#include <stdio.h>
#include <stdlib.h>

#define MAX           1000
#define PARENT(i)     (i-1)/2
#define LEFT(i)       2*i+1
#define RIGHT(i)      2*i+2

typedef int Elem; // elementos da heap.

typedef struct { 
        int size; 
        Elem heap[MAX];
} Heap;

void bubbleUp(Heap *h, int i) {
	Elem aux;
	if (i > 0) {
		if (h->heap[i] < h->heap[PARENT(i)]) {
			aux=h->heap[i];
			h->heap[i]=h->heap[PARENT(i)];
			h->heap[PARENT(i)] = aux;
			bubbleUp(h,PARENT(i));
		}
	}
}

int insertHeap(Heap *h, Elem x) {
	if (h->size == MAX)
		return 0;
	h->heap[h->size]=x;
	bubbleUp(h,h->size);
	h->size++;
	return 1;
}

void bubbleDown(Heap *h, int i) {
	Elem aux;
	int min;
	if (LEFT(i) < h->size) {
		if (RIGHT(i) < h->size) {
			if (h->heap[RIGHT(i)] < h->heap[LEFT(i)]) {
				min = RIGHT(i);
			}
			else {
				min = LEFT(i);
			}
			if (h->heap[i] > h->heap[min]) {
				aux=h->heap[i];
				h->heap[i]=h->heap[min];
				h->heap[min] = aux;
				bubbleDown(h,min);
			}
		}
		else if (h->heap[i] > h->heap[LEFT(i)]) {
			aux=h->heap[i];
			h->heap[i]=h->heap[LEFT(i)];
			h->heap[LEFT(i)] = aux;
			bubbleDown(h,LEFT(i));
		}
	}	
} 

int extractMin(Heap*h,Elem*x) {
	if (h->size == 0)
		return 0;
	*x = h->heap[0];
	h->size--;	
	h->heap[0]=h->heap[h->size];
	bubbleDown(h,0);
	return 1;	
}

int main(void) {
	Heap heap;
	Elem r;
	insertHeap(&heap,4);
	insertHeap(&heap,5);
	insertHeap(&heap,3);
	insertHeap(&heap,7);
	insertHeap(&heap,9);
	insertHeap(&heap,1);
	while (extractMin(&heap,&r)) {
		printf("%d\n",r);
	}
	return 0;
}