#include <stdio.h>
#include <stdlib.h>

typedef struct node { 
	int elem; 
	struct node *esq; 
	struct node *dir;
} Node, *Tree;

Tree insert(Tree t, int x) {
	if (!t) {
		Node *new = (Node *)malloc(sizeof(Node));
		new -> elem = x;
		new -> esq = NULL;
		new -> dir = NULL;
		return new;	
	}
	if (x < t -> elem) {
		t -> esq = insert(t->esq,x);
	}
	else {
		t -> dir = insert(t->dir,x);		
	}
	return t;
}

Tree extractMin(Tree t, int *x) { // extrai o menor elemento da  arvore
	Node *aux;
	if (t) {
		if (t->esq) {
			t->esq = extractMin(t->esq,x);
		}
		else {
			*x = t->elem;
			aux = t;
			t = t->dir;
			free(aux);
		}
	}
	return t;
} 

int exists(Tree t, int x) {	// verifica se um elemento esta na  arvore 
	if (t) {
		if (t -> elem == x) {
			return 1;
		}
		else if (x < t -> elem) {
			return exists(t->esq,x);
		}
		else {
			return exists(t->dir,x);
		}
	}
	else {
		return 0;
	}
}

int sum(Tree t) {	// calcula a soma de todos os elementos da  arvore
	if (t) {
		return (t->elem+sum(t->esq)+sum(t->dir));
	}
	else {
		return 0;
	}
}

int main(void) {
	Tree t=NULL;
	int r;
	t = insert(t,4);
	t = insert(t,3);
	t = insert(t,8);
	t = insert(t,5);
	t = insert(t,9);
	printf("%d\n",sum(t));
	printf("%d\n",exists(t,3));
	t = extractMin(t,&r);
	printf("%d\n",r);
	printf("%d\n",exists(t,3));
	printf("%d\n",sum(t));
	return 0;	
}